#ifndef __DMAVIF0_H__
#define __DMAVIF0_H__


#include "dmawrap.h"


class CDmaVif0 : public CDmaWrap
{
public:
	CDmaVif0(void * pDmaMem, uint32 uDmaQuadSize, TRANS_MODE trans_mode=TRANS_CHAINED) : CDmaWrap(pDmaMem,uDmaQuadSize,trans_mode) { m_bSetTTE=true; }

	void Launch(int iSPS2Device=-1);
	void Wait();
	void DisableTTE();

private:
};




inline void CDmaVif0::Launch(int iSPS2Device)
{
	asm("sync.l");
	assert(((*EE_D0_CHCR)&0x0100) == 0);

	switch(m_uTransMode)
	{
		case TRANS_NORMAL:
			*EE_D0_MADR = (uint32) m_pStartPhys&0x8fffffff;
			*EE_D0_QWC = (uint32) m_uDmaQuadSize;

			#ifdef DEBUG_DMA
			if (iSPS2Device>=0) {
			  sps2ValidateDMA(iSPS2Device,0,GenCHCR(0,0,0,0,0,1),0);
			}
			#endif

			*EE_D0_CHCR = GenCHCR(0,0,0,0,0,1);
			break;
		case TRANS_CHAINED:
			*EE_D0_QWC = 0;
			*EE_D0_TADR = (uint32) m_pStartPhys&0x8fffffff;


			#ifdef DEBUG_DMA
			if (iSPS2Device>=0) {
			  sps2ValidateDMA(iSPS2Device,0,
					  GenCHCR(0,1,0,((m_bSetTTE)?1:0),0,1),
					  0);
			}
			#endif

			*EE_D0_CHCR = GenCHCR(0,1,0,((m_bSetTTE)?1:0),0,1);
			break;
		default:
			assert(false);	// unknown specification
	}

	asm("sync.l");
}

inline void CDmaVif0::Wait()
{
	while((*EE_D0_CHCR)&0x0100)
		;
}


inline void CDmaVif0::DisableTTE()
{
	m_bSetTTE = false;	
}



#endif
