/**
 * The following class is just a wrapper to the sps2 utility functions that
 * handle the screen.
 * If you need more control over the display than is provided by this class
 * you may want to consider using screen_template.cpp/h as a template from
 * which to create your own display handling code.
 */
#ifndef __SCREEN_H__
#define __SCREEN_H__

#include "exttypes.h"
#include <sps2util.h>

#define SCR_VESA SPS2U_SCR_VESA
#define SCR_NTSC SPS2U_SCR_NTSC
#define SCR_PAL SPS2U_SCR_PAL

class CScreen
{
public:
	/**
	 * NOTE: By defaults, the signal handlers that sps2UScreenInit offers
	 * are *suppressed*.  This means that it is your responsibility to
	 * handle all signals gracefully.
	 * Please see the documentation to sps2UScreenInit for more details.
	 */
	void ScreenSetup(int iSuppressSignalHandlers=1);

	void Swap();
	uint32 GetFirstFreeGsPage();
	uint32 GetDrawFptr();
	uint32 GetZptr();
	uint32 GetDrawBuff1();
	uint32 GetDrawBuff2();
	uint32 GetWidth();
	uint32 GetHeight();
	uint32 GetDepth();
	uint32 GetMode();

	CScreen();
	~CScreen();

};


#endif
