#ifndef __IMESHINSTANCE_H__
#define __IMESHINSTANCE_H__

#include <geommath/geommath.h>
#include "dmavif1.h"


class IMesh;


class IMeshInstance 
{	
public:
	void Draw(Mat44 m, Mat44 ToScr);
	void * GetDMA_Tags() { return m_pDmaTags; }
	CDmaVif1 * GetDmaChain() { return m_pDmaVif1; }

	IMeshInstance(IMesh * pMotherMesh, CDmaVif1 * pDmaVif1);

private:
	void InitDMA_List();

	int m_pObjSpace[4];	// iNumClipPlanes, iNumLights, xxx, yyy
	int m_iNumClipPlanes;

	IMesh * m_pMotherMesh;
	CDmaVif1 * m_pDmaVif1;
	void * m_pDmaTags;

	void * m_pWorldToScreen[8];
	void * m_pLocToWorld[8];
};


#endif
